#include "faidx.h"
//generic struct for holding the faidx, the mutex and the actual data.
typedef struct{
  pthread_mutex_t aMut;//mutex will be locked unlocked whenever we do something
  faidx_t *fai;//contains the faidx structure
  char *seqs;//contains the reference for the current chr;
  char *curChr;//the exact chromosome name for the seqs above
  int chrLen;//length of chromosome
}perFasta;

char *loadChr(perFasta *f,const char*fname);

class getFasta : public general{
public:
  perFasta *ref;
  perFasta *anc;
  char *magic(const loci *locs,int numSites,perFasta *f);
  
  getFasta(argStruct *arguments);
  ~getFasta();
  void printArg(FILE *argFile,const char *refName,const char *ancName);
  void getOptions(argStruct *arguments);
  void run(funkyPars  *pars);//plugs in reference and ancestral
  void print(funkyPars *pars);
  void clean(funkyPars *pars);
  
  //this is solely used for testing with the fonseca stuff tsk 488
  char* hidden(){return ref->seqs;}
  char* hidden2(const char*fname){return loadChr(ref,fname);}
};
